<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css"
        integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">
</head>

<body>
    <div id="app" class="container">
        <div class="row">
            <div class="col">
                <form @submit.prevent="submitMembers()">
                    <p v-if="errors.length">
                        <b>Please correct the following errors: </b>
                        <ul>
                            <li v-for="error in errors">
                                {{ error }}
                            </li>
                        </ul>
                    </p>
                    <div class="form-group">
                        <label>Nama</label>
                        <input v-model="name" type="text" :disabled="buttonStatus === 'upload'" class="form-control">
                    </div>
                    <div class="form-group">
                        <label>No. HP</label>
                        <input v-model="no_hp" type="number" :disabled="buttonStatus === 'upload'" class="form-control">
                    </div>
                    <div class="form-group">
                        <label>Alamat</label>
                        <textarea v-model="address" :disabled="buttonStatus === 'upload'" class="form-control" cols="30" rows="5"></textarea>
                    </div>
                    <div v-if="buttonStatus === 'tambah'">
                        <button type="submit" class="btn btn-primary">Submit</button>
                    </div>
                    <div v-else-if="buttonStatus === 'update'">
                        <button @click="updateMember(idEditMember)" type="button" class="btn btn-warning">Update</button>
                        <button @click="clearForm" class="btn btn-primary">Clear</button>
                    </div>
                    <div v-else-if="buttonStatus === 'upload'">
                        <input type="file" class="form-control my-3" name="photo_profile" ref="photo_profile">
                        <button @click="submitPhoto(idUploadMember)" type="button" class="btn btn-secondary">Upload Photo</button>
                        <button @click="clearForm" class="btn btn-primary">Clear</button>
                    </div>
                    
                </form>
            </div>
            <div class="col">
                <table class="table">
                    <thead>
                        <tr>
                            <th scope="col">Nama</th>
                            <th scope="col">No. HP</th>
                            <th scope="col">Alamat</th>
                            <th scope="col">Foto Profil</th>
                            <th scope="col">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="member of members">
                            <td>{{ member.name }}</td>
                            <td>{{ member.no_hp }}</td>
                            <td>{{ member.address }}</td>
                            <td><img width="50px" :src="member.photo_profile ? domain + member.photo_profile : 'https://sanbercode.com/logo-kanan.png'" alt=""></td>
                            <td>
                                <a @click="editMember(member)" class="btn btn-warning btn-sm my-1">Edit</a>
                                <a @click="removeMember(member.id)" class="btn btn-danger btn-sm my-1">Delete</a>
                                <a @click="uploadPhoto(member)" class="btn btn-info btn-sm my-1">Upload</a>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>

    </div>

    <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
    <script src="https://unpkg.com/axios/dist/axios.min.js"></script>
    <script>
        var vm = new Vue({
            el: '#app',
            data: {
                members: [],
                domain: 'http://demo-api-vue.sanbercloud.com',
                name: '',
                no_hp: '',
                address: '',
                errors : [],
                idEditMember: null,
                idUploadMember: null,
                buttonStatus: 'tambah'

            },

            methods: {
                validationForm: function(){
                    this.error = []

                    if(this.name == 0) {
                        this.errors.push("Nama tidak boleh kosong")
                    }

                    if(this.no_hp < 10 ) {
                        this.errors.push("No HP minimal 10 karakter")
                    }

                    if(this.address == 0){
                        this.errors.push("Alamat tidak boleh kosong.")
                    }
                },

                editMember : function(member){
                    this.name = member.name
                    this.no_hp = member.no_hp
                    this.address = member.address
                    this.idEditMember = member.id 
                    this.buttonStatus = 'update'
                },

                getMember: function() {
                    const config = {
                        method: 'get',
                        url: 'http://demo-api-vue.sanbercloud.com/api/member'
                    }

                    axios(config)
                        .then((response) => {
                            this.members = response.data.members
                        })
                        .catch((error) =>{
                            console.log(error)
                        })
                },
                
                uploadPhoto: function(member){
                    this.name = member.name
                    this.no_hp = member.no_hp
                    this.address = member.address
                    this.idUploadMember = member.id
                    this.buttonStatus = 'upload'

                },

                updateMember: function(id){
                    this.validationForm();

                    if(this.errors.length === 0){
                        let formData = new FormData()
                        formData.append('name', this.name)
                        formData.append('no_hp', this.no_hp)
                        formData.append('address', this.address)

                        const config = {
                            method : 'post',
                            url : this.domain + '/api/member/' + id,
                            params : {_method: 'PUT'},
                            data : formData
                        }

                        console.log(config.url)

                        axios(config)
                        .then((response) => {
                            this.clearForm()
                            this.getMember()
                            alert(response.data.message);
                        })
                        .catch((error) => {
                            console.log(error)
                        })
                    }
                },

                removeMember: function(id){
                    const config = {
                        method: 'post',
                        url: `${this.domain}/api/member/${id}`,
                        params: {_method: 'Delete'},
                    }
                    axios(config)
                    .then((response) => {
                        this.getMember()
                        alert(response.data.message);
                    })
                    .catch((error) => {
                        console.log(error)
                    })
                },

                submitPhoto: function(id){
                    let file = this.$refs.photo_profile.files[0]

                    let formData = new FormData();
                    formData.append('photo_profile', file)

                    const config = {
                        method: 'post',
                        url: `${this.domain}/api/member/${id}/upload-photo-profile`,
                        data: formData
                    }

                    axios(config)
                        .then((response) => {
                            this.clearForm()
                            this.getMember()
                            alert(response.data.message);
                        })
                        .catch((error) => {
                            console.log(error)
                        })
                },

                clearForm : function(){
                    this.name = ''
                    this.no_hp = ''
                    this.address = ''
                    this.idEditMember = null
                    this.idUploadMember = null
                    this.buttonStatus = 'tambah'
                },

                submitMembers: function(){
                    this.validationForm();

                    let formData = new FormData()
                    formData.append('name', this.name)
                    formData.append('no_hp', this.no_hp)
                    formData.append('address', this.address)

                    if(this.errors.length === 0){
                        const config = {
                            method : 'post',
                            url : this.domain + '/api/member',
                            data : formData
                        }
                        axios(config)
                        .then((response) => {
                            this.clearForm()
                            this.getMember()
                            console.log(response.data)
                            alert(response.data.message)
                        })
                        .catch((error) => {
                            console.log(error)
                        })
                    }
                }
            },
            created() {
                this.getMember();
            }
        })
    </script>
</body>

</html>